import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileChildrenHistory } from "../entities/ProfileChildrenHistory";
import { RequestWithUser } from "../middlewares/user";
import {
  CreateProfileChildrenEmployee,
  ProfileChildren,
  UpdateProfileChildren,
} from "../entities/ProfileChildren";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import Extension from "../interfaces/extension";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/family/children")
@Tags("ProfileChildren")
@Security("bearerAuth")
export class ProfileChildrenEmployeeController extends Controller {
  private profileRepository = AppDataSource.getRepository(ProfileEmployee);
  private childrenRepository = AppDataSource.getRepository(ProfileChildren);
  private childrenHistoryRepository = AppDataSource.getRepository(ProfileChildrenHistory);

  @Get("user")
  public async getChildrenUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileRepository.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const lists = await this.childrenRepository.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("{profileEmployeeId}")
  public async getChildren(@Path() profileEmployeeId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileEmployeeId);
    const lists = await this.childrenRepository.find({
      where: { profileEmployeeId: profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("history/{childrenId}")
  public async childrenHistory(@Path() childrenId: string, @Request() req: RequestWithUser) {
    const _record = await this.childrenRepository.findOneBy({ id: childrenId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, childrenId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }
    const record = await this.childrenHistoryRepository.find({
      where: { profileChildrenId: childrenId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newChildren(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileChildrenEmployee,
  ) {
    const profile = await this.profileRepository.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileChildren();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    data.childrenCitizenId = Extension.CheckCitizen(String(data.childrenCitizenId));

    const history = new ProfileChildrenHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.childrenRepository.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileChildrenId = data.id;
    await this.childrenHistoryRepository.save(history, { data: req });
    setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{childrenId}")
  public async editChildren(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileChildren,
    @Path() childrenId: string,
  ) {
    const record = await this.childrenRepository.findOneBy({ id: childrenId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    // const before_null = null;
    const history = new ProfileChildrenHistory();
    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    record.childrenCitizenId = Extension.CheckCitizen(String(record.childrenCitizenId));
    history.profileChildrenId = record.id;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.childrenRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.childrenHistoryRepository.save(history, { data: req }),
      // setLogDataDiff(req, { before: before_null, after: history }),
    ]);

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลบุตร
   * @summary API ลบข้อมูลบุตร
   * @param trainingId คีย์บุตร
   */
  @Patch("update-delete/{childrenId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() childrenId: string,
  ) {
    const record = await this.childrenRepository.findOneBy({ id: childrenId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileChildrenHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileChildrenId = childrenId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.childrenRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.childrenHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{childrenId}")
  public async deleteTraning(@Path() childrenId: string, @Request() req: RequestWithUser) {
    const _record = await this.childrenRepository.findOneBy({ id: childrenId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }
    await this.childrenHistoryRepository.delete({
      profileChildrenId: childrenId,
    });

    const result = await this.childrenRepository.delete({ id: childrenId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
